import { Resolver, ResolveOptions, MinimalResolveOptions } from '@yarnpkg/core';
import { Descriptor, Locator, DescriptorHash, Package } from '@yarnpkg/core';
import { LinkType } from '@yarnpkg/core';
export declare class ExecResolver implements Resolver {
    supportsDescriptor(descriptor: Descriptor, opts: MinimalResolveOptions): boolean;
    supportsLocator(locator: Locator, opts: MinimalResolveOptions): boolean;
    shouldPersistResolution(locator: Locator, opts: MinimalResolveOptions): boolean;
    bindDescriptor(descriptor: Descriptor, fromLocator: Locator, opts: MinimalResolveOptions): Descriptor;
    getResolutionDependencies(descriptor: Descriptor, opts: MinimalResolveOptions): never[];
    getCandidates(descriptor: Descriptor, dependencies: Map<DescriptorHash, Package>, opts: ResolveOptions): Promise<Locator[]>;
    resolve(locator: Locator, opts: ResolveOptions): Promise<{
        version: string;
        languageName: any;
        linkType: LinkType;
        dependencies: Map<import("../../yarnpkg-core/sources").IdentHash, Descriptor>;
        peerDependencies: Map<import("../../yarnpkg-core/sources").IdentHash, Descriptor>;
        dependenciesMeta: Map<string, Map<string | null, import("../../yarnpkg-core/sources").DependencyMeta>>;
        peerDependenciesMeta: Map<string, import("../../yarnpkg-core/sources").PeerDependencyMeta>;
        bin: Map<string, import("../../yarnpkg-fslib/sources").PortablePath>;
        locatorHash: import("../../yarnpkg-core/sources").LocatorHash;
        reference: string;
        identHash: import("../../yarnpkg-core/sources").IdentHash;
        scope: string | null;
        name: string;
    }>;
}
